<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../common/meta';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CopyForm, NextStepAlt } from '../components/common/index.vue';
import { FifteenHero } from '~/components/fifteen/index.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { getClient } from '../plugins/contentful';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { seventeenDataHelper } from '~/services/seventeen.service';
import { SolutionsVideoModal as VideoModal } from '~/components/solutions/index.vue';
import { VideoBlock } from '~/components/seventeen/index.vue';
import { UseLiteVimeo } from '~/mixins/use-lite-vimeo.mixin';

export default Vue.extend({
  name: 'Seventeen',
  components: {
    FifteenHero,
    CopyForm,
    NextStepAlt,
    VideoBlock,
    VideoModal,
  },
  mixins: [LivePreviewMixin, FooterEditLinkMixin, UseLiteVimeo],
  layout: 'no-banner',
  async asyncData({ i18n }: any) {
    try {
      const { items } = await await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '1UD2moMp7WqvJaSB84aLSI',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });
      const { pageContent, seoMetadata } = items[0].fields;

      const page = seventeenDataHelper(pageContent, seoMetadata);

      return { items, page };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      showModal: false,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).page,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.page = seventeenDataHelper(
            updatedData[0].fields.pageContent,
            updatedData[0].fields.seoMetadata,
          )),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <section>
    <FifteenHero :data="page.hero_image_block" />
    <SlpContainer class="copy-form seventeen-form-section">
      <CopyForm :data="page.register_form_block" />
    </SlpContainer>
    <div
      v-if="page.video_block"
      id="gradient-background"
      class="gradient-background"
    >
      <VideoBlock :data="page.video_block" @openModal="openModal" />
    </div>
    <SlpContainer variant="gradient">
      <NextStepAlt />
    </SlpContainer>
    <VideoModal
      v-show="showModal && page.video_block"
      light-background
      :visible="showModal"
      @close="showModal = false"
    >
      <template #body>
        <lite-vimeo
          :videoid="getVimeoVideoId(page.video_block?.url)"
          title="Video player"
          autoplay
          allowfullscreen
        ></lite-vimeo>
      </template>
    </VideoModal>
  </section>
</template>

<style scoped lang="scss">
.copy-form {
  padding-top: $spacing-48;

  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0 $spacing-64;
  }
}
.seventeen-form-section {
  :deep {
    .mktoFieldDescriptor.mktoFormCol {
      .mktoLabel.mktoHasWidth {
        text-transform: lowercase !important;
      }
      .mktoLabel.mktoHasWidth#LbleventDateCode1 {
        text-transform: none !important;
      }
    }
  }
}
#gradient-background,
.gradient-background {
  width: 100%;
  background: radial-gradient(
      59.78% 45.32% at 31.69% 94.07%,
      rgba(226, 67, 41, 0.2) 0%,
      rgba(226, 67, 41, 0.03) 100%
    ),
    linear-gradient(to bottom, #232150 0.03%, #232150 99.98%);
}
</style>
